VERSION 5.00
Begin VB.Form frm_CHART 
   AutoRedraw      =   -1  'True
   BackColor       =   &H80000005&
   Caption         =   "Chart"
   ClientHeight    =   1185
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   4020
   Icon            =   "frm_CHART.frx":0000
   KeyPreview      =   -1  'True
   LinkTopic       =   "Form1"
   LockControls    =   -1  'True
   MDIChild        =   -1  'True
   ScaleHeight     =   1185
   ScaleWidth      =   4020
   Visible         =   0   'False
   WindowState     =   2  'Maximiert
   Begin VB.PictureBox lbLegend 
      Appearance      =   0  '2D
      AutoRedraw      =   -1  'True
      BackColor       =   &H00E0E0E0&
      BorderStyle     =   0  'Kein
      DrawStyle       =   5  'Transparent
      FillColor       =   &H00FFFFFF&
      ForeColor       =   &H80000008&
      Height          =   735
      Left            =   735
      ScaleHeight     =   735
      ScaleWidth      =   1815
      TabIndex        =   4
      Top             =   120
      Width           =   1815
   End
   Begin VB.HScrollBar HScroll 
      Height          =   180
      Left            =   915
      Max             =   0
      SmallChange     =   4
      TabIndex        =   3
      Top             =   960
      Visible         =   0   'False
      Width           =   3000
   End
   Begin VB.HScrollBar XScroll 
      Height          =   180
      Left            =   330
      TabIndex        =   2
      Top             =   960
      Visible         =   0   'False
      Width           =   420
   End
   Begin VB.CommandButton dummy 
      Caption         =   "0"
      Height          =   195
      Left            =   150
      TabIndex        =   1
      Top             =   120
      Width           =   150
   End
   Begin VB.VScrollBar YScroll 
      Height          =   420
      Left            =   120
      TabIndex        =   0
      Top             =   480
      Width           =   180
   End
   Begin VB.Line MLine 
      Visible         =   0   'False
      X1              =   2760
      X2              =   2760
      Y1              =   120
      Y2              =   840
   End
End
Attribute VB_Name = "frm_CHART"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'################################################################################
'
' Chart Klasse
'
Option Explicit
      Private Declare Function GetCursorPos Lib "user32" (lpPoint As POINTAPI) As Long
      Private Declare Function SetWindowPos Lib "user32" (ByVal hWnd As Long, ByVal hwndInsertAfter As Long, ByVal X As Long, ByVal Y As Long, ByVal cx As Long, ByVal cy As Long, ByVal wFlags As Long) As Long

      Private Const SWP_NOMOVE = &H2
      Private Const SWP_NOSIZE = &H1
      Private Const HWND_TOPMOST = -1
      Private Const HWND_NOTOPMOST = -2
      Private Type POINTAPI
          X As Long
          Y As Long
      End Type
      'Private Const cYNull = -100000 'siehe mod_help
'##################   Form Eigenschaften  ##################################

      Public iCIndex As Integer

'##################   Diagramm Eigenschaften  ##################################
      
      'Default
      Const cCht_ColMin = 95         'Werte Count Min
      
'Y Achse
      Public sCht_YLName As String   'Legendenbezeichnung
      Public lCht_YMaxVal As Long    'Max Wert
      Public lCht_YMinVal As Long    'Min Wert

'X Achse
      Public sCht_XLName As String            'Legendenbezeichnung
      Public iCht_XMaxVal As Integer          'Max Wert
      Public iCht_XMaxValVirtuel As Integer   'Spalten Count Genau = nicht alles sichtbar
      Public iCht_XMaxValScroll As Integer    'Spalten Max Wert fr horizontale Verschiebung (unsichtbarer Bereich)
      Public iCht_XMinVal As Integer          'Min Wert
      Public iCht_XMinValOffs As Integer      'Spalten Min Wert fr horizontale Verschiebung

'Sonstige#
      Public lCht_FSize  As Long      'Fontgre
      Public sCht_Titel  As String    'Titel
      Public bMPunkte As Boolean      'Messpunkte Zeichnen
      Public bHDatum As Boolean       'Datum Zeichnen
      Private bMWerte As Boolean      'Messwerte Anzeigen
      Public bLegende As Boolean     'Legende Anzeigen
      
'Messwertanzeige
      Public lCht_MWXMin As Long
      Public lCht_MWXBereich As Long
      Public lCht_MWXCol As Long
      Public lCht_MWXCount As Long
      
      Public lCht_MWXBeginn As Long
      
'##################   Steuer Eigenschaften  ##################################

'Linienfeld
      Public Lines As Collection

'CollectionKey
      Public ObjKey As String

'#########################    CHART    ##########################

'###################   Public Sub | Function  ###################

'Linien neu berechnen/neuzeichnen
      Public Sub ChartRefresh()
            Me.Cls
            CDraw.ACSet Me, lHeight, lWidth
            CDraw.ACDraw
            FormRefresh
          End Sub
          
'Zeilen Intervall
      Public Sub YIntervall(i As Integer)
          Dim c
          c = lCht_YMaxVal / 5
          c = val(Left(Trim(Str(c)), 1)) * val("1" & Replace(Space(Len(Str(c)) - 2), " ", "0"))
          Select Case i
          Case 1: lCht_YMaxVal = lCht_YMaxVal + c
          Case -1: lCht_YMaxVal = lCht_YMaxVal - c
          End Select
          ChartRefresh
          End Sub
          
'Spalten MaxValue
      Public Sub XMaxScroll(i As Integer, Optional noRsh)
          Dim ColMax As Integer
          ColMax = iCht_XMaxVal
          Select Case i
          Case -1: ColMax = IIf(ColMax + 96 <= iCht_XMaxValVirtuel, ColMax + 96, iCht_XMaxValVirtuel)
          Case 1: ColMax = IIf(ColMax - 96 >= iCht_XMinVal, ColMax - 96, iCht_XMinVal)
          End Select
          If ColMax = iCht_XMaxVal Then Exit Sub
          iCht_XMaxVal = ColMax
          If IsMissing(noRsh) Then ChartRefresh
          End Sub

'Spalten MinValue
      Public Sub XMinScroll(i As Integer)
          If iCht_XMinValOffs <> i Then iCht_XMinValOffs = i:  ChartRefresh
          End Sub

'Messwert Beginn
      Public Sub MWXBeginn(i)
          If lCht_MWXBeginn <> i Then lCht_MWXBeginn = i:  ChartRefresh
          End Sub
          
'##################   Private Sub | Function  ##################

'Initialize/Terminate
      Public Sub ChartInitialize()
         ' Me.BackColor = &H80000005 '&H80000000
          bMPunkte = False
          'bHDatum = False
          sCht_Titel = App.ProductName
         ' sCht_YLName = "MW"
         ' sCht_XLName = "Uhr"
         ' lCht_YMaxVal = 10000 'Y Achse default
          iCht_XMinVal = cCht_ColMin
          iCht_XMinValOffs = 0
          lCht_FSize = 14
          Set Lines = New Collection
          End Sub
          
      Private Sub ChartTerminate()
          Set Lines = Nothing
          End Sub
         
'#########################    FORM    ##########################

'##################   Public Sub | Function  ##################

'Chart Zeichenflche
'Chart Grsse lesen fr GDI
      Public Property Get lWidth() As Long
          lWidth = CDraw.TwipsToPixelX(Me.ScaleWidth)
          End Property
          
      Public Property Get lHeight() As Long
          lHeight = CDraw.TwipsToPixelY(Me.ScaleHeight)
          End Property
          
      Public Property Let Legende(vNewValue As Boolean)
          lbLegend.VISIBLE = vNewValue
          End Property
          
      Private Sub Form_Activate()
          MainProzess CRefresh
          End Sub

'##################   Private Sub | Function  ##################

      Private Sub Form_Initialize()
          On Error Resume Next
          ChartInitialize
          CDraw.ACIniziale
          Form_Iniziale
          ChartRefresh
          Me.VISIBLE = True
          If err <> 0 Then Unload Me
          End Sub

'###################################################################################################

'Messwerte ein / aus
      Private Sub Form_Click()

          End Sub
          
      Private Sub Form_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
          Static SbMPunkte As Boolean
          If Button <> 2 Then bMWerte = True
          bMWerte = Not bMWerte
          If bMWerte Then SbMPunkte = bMPunkte: bMPunkte = bMWerte Else bMPunkte = SbMPunkte
          With MLine
            .VISIBLE = bMWerte
            .y1 = 0
            .Y2 = Me.Height
          End With
          If Not bMWerte Then frm_Help.VISIBLE = False
          ChartRefresh
          End Sub

'Messwerte anzeigen
      Private Sub Form_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
          On Error Resume Next
          Static SMWpos As Long
          Dim pos As Long
          Dim col As Long
          Dim DLGPos As Long
          Dim MWpos As Long
          Dim MWposOffs As Long
          Dim Line As cls_Line
          Static s$, i%
        Dim MPoint As POINTAPI
        Dim xMPoint As Long
        Dim YMPoint As Long
        Dim XFak As Double
          If bMWerte Then
            pos = X / Screen.TwipsPerPixelX - lCht_MWXMin
            XFak = lCht_MWXBereich / lCht_MWXCount
            col = (pos) / XFak
            MWpos = (col * XFak + lCht_MWXMin) * Screen.TwipsPerPixelY
            If SMWpos <> MWpos Then
              SMWpos = MWpos
              If col > -1 And col < lCht_MWXCount + 1 Then
                  With MLine
                    .x1 = MWpos
                    .X2 = .x1
                  End With
                  col = col + iCht_XMinValOffs + IIf(lCht_MWXBeginn = 1, 0, 1)
                  i = 1
                  s$ = "Zeit " + ColToZeit(col) + " | " + _
                       "Spalte  " + Str(col) + Chr(13) + Chr(13)
                  For Each Line In Lines
                      With Line
                        If col <= .ValCount Then
                          If .Value(col) <> cYNull Then s$ = s$ + _
                          Format(Str(i), "(##00) ") + Format(Str(.Value(col)), "= @@@@@@ ") + _
                          "  " + .QUELLE + " " + Chr(13)
                        End If
                      End With
                      i = i + 1
                  Next
                  i = Lines.Count + 3
              End If
            End If
            If Y < 300 Or Y > Str(Me.ScaleHeight) - 300 Or _
               X < 200 Or X > Str(Me.ScaleWidth) - 120 Then
                frm_Help.VISIBLE = False
                'Form_Click
            Else
              With frm_Help
                  .lblHelp = s$ ' "x :" + Str(x) + Chr(13) + "Width:" + Str(Me.ScaleWidth)   ' s$
                  GetCursorPos MPoint
                  .Left = Screen.TwipsPerPixelX * ((MPoint.X)) + IIf(X > Str(Me.ScaleWidth) - .Width, -.Width, 150)
                  .Top = Screen.TwipsPerPixelY * ((MPoint.Y)) + IIf(X > Str(Me.ScaleWidth) - .Width, -1200, 350)
                  .Width = frm_Help.lblHelp.Width + 150
                  .Height = 80 + 195 * i
                  .VISIBLE = True
                  SetWindowPos .hWnd, HWND_TOPMOST, 0, 0, 0, 0, SWP_NOMOVE + SWP_NOSIZE
              End With
            End If
          End If
          End Sub

'###################################################################################################
   
      Private Sub Form_Terminate()
          ChartTerminate
          End Sub
          
      Private Sub Form_Resize()
          ChartRefresh
          End Sub
          
      Private Sub FormRefresh()
          On Error Resume Next
          With Me
            If .WindowState = vbNormal Then  'Mindestgrsse
              If .Height < 4500 Then .Height = 4500
              If .Width < 6000 Then .Width = 6000
              If .Height + 1320 > mdi.Height Then .Top = 0: .Height = mdi.Height - 1320
              If .Width + 120 > mdi.Width Then .Left = 0: .Width = mdi.Width - 120
            End If
            YScroll.Top = .Height - 1000
            'Locale Steuerung
'            XScroll.Top = .Height - 600
'            HScroll.Top = .Height - 600
'            HScroll.Width = .Width - 1000
'            HScroll.Min = iCht_XMaxValScroll
'            XScroll.VISIBLE = IIf(iCht_XMaxValVirtuel > iCht_XMinVal, True, False)
'            HScroll.VISIBLE = .XScroll.VISIBLE
            dummy.SetFocus
          End With
          End Sub

'Legende verschieben
      Private Sub lbLegend_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
          Static aLock
          If aLock Then Exit Sub
          aLock = True
          CDraw.LegendeDrag
          aLock = False
          End Sub
      Private Sub Form_DragDrop(Source As Control, X As Single, Y As Single)
          CDraw.LegendeDrop
          End Sub

'Chart Zeileninteval/max - Zahl ndern
      Private Sub YScroll_Change()
          If YScroll.Value = 0 Then Exit Sub
          YIntervall YScroll.Value '(1 | -1)
          YScroll.Value = 0
          dummy.SetFocus
          End Sub

'Chart Spalteninteval - MaxZahl ndern
      Private Sub XScroll_Change()
          If XScroll.Value = 0 Then Exit Sub
          XMaxScroll XScroll.Value
          XScroll.Value = 0
          dummy.SetFocus
          End Sub

'Chart Spalteninteval - MinZahl ndern
      Private Sub hScroll_Change()
          XMinScroll HScroll.Value
          dummy.SetFocus
          End Sub
          
'Chart initialisieren
      Private Sub Form_Iniziale()
          dummy.Left = -2000
          YScroll.Left = 50
          YScroll.Max = 1
          YScroll.min = -1
          YScroll.Value = 0
          YScroll.SmallChange = 1
          XScroll.Left = 250
          XScroll.Max = 1
          XScroll.min = -1
          XScroll.Value = 0
          XScroll.SmallChange = 1
          HScroll.Left = 700
          HScroll.Max = 0
          HScroll.min = 0
          HScroll.Value = 0
          HScroll.SmallChange = 4
          lbLegend.Left = 1100
          lbLegend.Top = 200
          End Sub




