VERSION 5.00
Begin VB.Form frmMain 
   Caption         =   "Messwerte graphisch darstellen"
   ClientHeight    =   3150
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   4680
   LinkTopic       =   "Form1"
   ScaleHeight     =   3150
   ScaleWidth      =   4680
   StartUpPosition =   3  'Windows-Standard
   Begin VB.CommandButton cmdParse 
      Caption         =   "&Daten auslesen"
      Height          =   375
      Left            =   3000
      TabIndex        =   1
      Top             =   2640
      Width           =   1575
   End
   Begin prjGraph.GraphControl Graph 
      Height          =   2655
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   3135
      _extentx        =   4895
      _extenty        =   4048
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Private WithEvents Parser       As CParser
Attribute Parser.VB_VarHelpID = -1

Private Sub cmdParse_Click()
    'Wir lesen zum Test die Daten vom 2.1.2004 ein. Spter wird man hier natrlich Now abfragen!
    Dim D As Date
    D = #1/2/2004 1:22:00 PM#
    If Parser.Parse(D) Then _
        Call Graph.ReadDatas
End Sub

Private Sub Form_Load()
    'Grundsettings ...
    Graph.Style = stlwinXP
    Graph.PointStyle = stlCircle
    Set Parser = New CParser
End Sub

Private Sub Form_Resize()
    'Forminhalt mavoll anpassen
    On Error Resume Next
    Graph.Width = Me.ScaleWidth - Graph.Left * 2
    Graph.Height = Me.ScaleHeight - Graph.Top * 3 - cmdParse.Height
    cmdParse.Top = Graph.Height + Graph.Top * 2
    cmdParse.Left = Me.ScaleWidth - Graph.Left - cmdParse.Width
    On Error GoTo 0
End Sub

Private Sub Parser_ParseError(m_Number As Long, m_Description As String)
    'Fehler im Parser. Wir geben sie per MessageBox aus
    'Grnde: Datei fr gesuchtes Datum existiert nicht oder ist fehlerhaft, etc.
    Call MsgBox(m_Description, vbExclamation, "Fehler Nr. " & m_Number)
End Sub
