VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Diagramm"
   ClientHeight    =   6600
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   10320
   LinkTopic       =   "Form1"
   ScaleHeight     =   6600
   ScaleWidth      =   10320
   StartUpPosition =   1  'Fenstermitte
   Begin VB.CommandButton Command3 
      Caption         =   "Einstellungen"
      Height          =   255
      Left            =   6120
      TabIndex        =   3
      Top             =   6120
      Width           =   1575
   End
   Begin VB.CommandButton Command2 
      Caption         =   "Diagramm"
      Height          =   255
      Left            =   7800
      TabIndex        =   2
      Top             =   6120
      Width           =   1215
   End
   Begin VB.CommandButton Command1 
      Caption         =   "Ende"
      Height          =   255
      Left            =   9120
      TabIndex        =   1
      Top             =   6120
      Width           =   975
   End
   Begin VB.PictureBox Picture1 
      BackColor       =   &H80000009&
      Height          =   5055
      Left            =   240
      ScaleHeight     =   4995
      ScaleWidth      =   9675
      TabIndex        =   0
      Top             =   720
      Width           =   9735
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Dim tabelle(1 To 2, 1 To 97) As String
Dim starttime As String
Function GetStarttime() As String
' Startzeit ggf auf letzte Viertelstund abrunden
GetStarttime = Format$(Time, "hh:mm")
Mid$(GetStarttime, 4, 2) = Format$(15 * Int((CInt(Mid$(GetStarttime, 4, 2)) / 15)), "00")

End Function
Private Sub fillarray()
' Uhrzeiten vorgeben
Dim sminuten As Long
Dim i
tabelle(1, 1) = starttime
sminuten = CLng(Left$(starttime, 2)) * 60 + CLng(Right$(starttime, 2))
For i = 2 To 97
    sminuten = sminuten + 15
    If sminuten = 1440 Then sminuten = sminuten - 1440 ' > 24h
    tabelle(1, i) = Format$((Int(sminuten / 60)), "00") + ":" + Format$(sminuten Mod 60, "00")
    tabelle(2, i) = ""
Next i
End Sub
Private Function GetYScale(Maxwert As Long) As Long
' Spannweite der Y-Skala ermitteln
Dim ifaktor As Long
Dim i As Integer
Dim j As Integer
Dim testwert As Long
ifaktor = 1
For i = 1 To 4
    For j = 0 To 10 Step 5
        testwert = j * ifaktor
        If testwert > Maxwert Then
            GetYScale = testwert
            Exit Function
        End If
    Next j
    ifaktor = testwert
Next i
End Function

Private Sub setpoints(bottomabst As Long)
' Punkte Setzen und ggf. mit Linie verbinden
Dim i, f
Dim x As Long
Dim x1 As Long
Dim sminuten As Long
Dim faktor As Long
Dim Wertvorhanden As Boolean
sminuten = CInt(Left$(tabelle(1, 1), 2)) * 60 + CInt(Right$(tabelle(1, 1), 2))
Wertvorhanden = False
For i = 1 To 97
    ' in minuten umrechnen
    x = CLng(Left$(tabelle(1, i), 2)) * 60 + CLng(Right$(tabelle(1, i), 2))
    If x = 0 Then  ' 00 Uhr umsprung
        faktor = CLng(Left$(tabelle(1, i - 1), 2)) * 60 + CLng(Right$(tabelle(1, i - 1), 2)) + 15
        With Picture1                       ' bei 0 Uhr Datum schreiben
            .ForeColor = XFontColor
            .Font = Xfontname
            .FontSize = XFontsize
            .FontBold = XFontbold
            .FontItalic = XFontItalic
            .CurrentY = -bottomabst - .TextHeight(Date)
        End With
        Picture1.Print Date
    End If
    If tabelle(2, i) <> "" Then             ' Punkt setzen
        Picture1.DrawWidth = 3
        Picture1.PSet (x - sminuten + faktor, CSng(tabelle(2, i))), WPointColor
        Picture1.DrawWidth = 1
        If Wertvorhanden Then       ' Punkt mit vorhergehendem verbinden
            x1 = CLng(Left$(tabelle(1, i - 1), 2)) * 60 + CLng(Right$(tabelle(1, i - 1), 2))
            If Left$(tabelle(1, i - 1), 5) = "23:45" Then
                f = 0
            Else
                f = faktor
            End If
            Picture1.Line (x1 - sminuten + f, CSng(tabelle(2, i - 1)))-(x - sminuten + faktor, CSng(tabelle(2, i))), WLineColor
        End If
        Wertvorhanden = True
    Else
        Wertvorhanden = False
    End If
Next i

End Sub

Private Sub Command1_Click()
End
End Sub
Function sucheinTabelle(Zeit As String) As Long
Dim i
For i = 1 To 97
    If tabelle(1, i) = Zeit Then
        sucheinTabelle = i
        Exit For
    End If
Next i
End Function
Private Function datenlesen() As Long
' Geht von jetzt 24 h zurck,ffnet die entsprechende Datei und beginnt ab dieser
' Uhrzeit mit dem Einlesen der Daten ins 2-dim Array Tabelle. Dabei wird der grte Wert
' ermittelt
Dim Dateiname1 As String
Dim Dateiname2 As String
Dim zeilenzahl As Long
Dim wminuten As Long
Dim sminuten As Long
Dim Maxwert As Long
Dim index As Long
Dim f As Long
Dim mx As Long
Dim Wertepaar As String
Dim x
Dateiname1 = Dateipfad + Format(Date - 1, "yyyymmdd") + ".txt"  ' Dateiname von gestern
Dateiname2 = Dateipfad + Format(Date, "yyyymmdd") + ".txt"          ' Dateiname von heute

sminuten = CLng(Left$(starttime, 2)) * 60 + CLng(Right$(starttime, 2))
f = FreeFile
zeilenzahl = 0
Maxwert = 0
On Error GoTo ferr
Open Dateiname1 For Input As #f
Do
    Line Input #f, Wertepaar
    Wertepaar = Trim$(Wertepaar)
    If (InStr(Wertepaar, ":")) > 0 Then
       wminuten = CInt(Left$(Wertepaar, 2)) * 60 + CInt(Mid$(Wertepaar, 4, 2))
       If wminuten >= sminuten Then     ' Werte lter als 24h auslassen
            index = 0
            index = sucheinTabelle(Left$(Wertepaar, 5))
            If index > 0 Then
                tabelle(2, index) = Right$(Wertepaar, Len(Wertepaar) - 6)
                mx = CLng(tabelle(2, index))
                If mx > Maxwert Then Maxwert = mx
            End If
       End If
    End If
Loop Until EOF(f)
Close f

f = FreeFile
'Datei von heute
Open Dateiname2 For Input As #f
Do
    Line Input #f, Wertepaar
    Wertepaar = Trim$(Wertepaar)
    If (InStr(Wertepaar, ":")) > 0 Then
        index = 0
        index = sucheinTabelle(Left$(Wertepaar, 5))
        If index > 0 Then
            If index = 1 Then index = 97    ' letzte Uhrzeit= 1.Uhrzeit
            tabelle(2, index) = Right$(Wertepaar, Len(Wertepaar) - 6)
            mx = CLng(tabelle(2, index))
            If mx > Maxwert Then Maxwert = mx
            If index = 97 Then Exit Do
        End If
    End If
    
Loop Until EOF(f)
Close f
datenlesen = Maxwert
Exit Function

ferr:
Close f
Beep
x = MsgBox(Error, vbExclamation, "Achtung")
datenlesen = 0
End Function

Private Sub setstandards()
With Picture1
    Yfontname = .Font
    YFontsize = .FontSize
    Xfontname = .Font
    XFontsize = .FontSize
End With
End Sub

Private Sub Koordinatensystem(MaxX As Long, MaxY As Long, XStep As Long, _
Ystep As Long, liAbst As Long, reAbst As Long, TopAbst As Long, bottomabst As Long)
Dim i, index
Dim FCOLOR As Long
AutoRedraw = True
' Rnder bei Skalierung bercks.
Picture1.Scale (-liAbst, (MaxY + TopAbst))-(MaxX + reAbst, 0 - bottomabst)
FCOLOR = Picture1.ForeColor
Picture1.Line (0, 0)-(0, MaxY), YLinecolor          ' Y-Achsel li.
Picture1.Line (MaxX, 0)-(MaxX, MaxY), YLinecolor    ' Y-Achsel re.
Picture1.Line (0, 0)-(MaxX, 0), XLinecolor          ' X-Achse
With Picture1
    .ForeColor = YFontColor
    .Font = Yfontname
    .FontSize = YFontsize
    .FontBold = YFontbold
    .FontItalic = YFontItalic
End With

For i = MaxY To Ystep Step -Ystep                   ' Alle 20% der Y-Achse Scale marks
    Picture1.Line (-10, i)-(0, i), YLinecolor       ' YScale marks li.
    Picture1.Line (0, i)-(MaxX, i), HLcolor         ' Horizontale Linien
    With Picture1
        .CurrentY = .CurrentY - .TextHeight(i) / 2
        .CurrentX = -.TextWidth(i) - 30
        Picture1.Print i                                ' Beschriftung li.
        Picture1.Line (MaxX, i)-(MaxX + 10, i), YLinecolor  ' YScale marks re.
        .CurrentX = MaxX + 10
        .CurrentY = .CurrentY - .TextHeight(i) / 2
        Picture1.Print i                                ' Beschriftung re.
    End With
Next i
index = 1
With Picture1
    .CurrentX = 0
    .ForeColor = XFontColor
    .Font = Xfontname
    .FontSize = XFontsize
    .FontBold = XFontbold
    .FontItalic = XFontItalic
    .CurrentY = -bottomabst - .TextHeight(Date)
    Picture1.Print (Date - 1)                           ' 1. Datum
    For i = 0 To MaxX Step XStep                        ' Alle 2 Std. X-Scale Marks
        Picture1.Line (i, 0)-(i, -(MaxY / 100)), XLinecolor
        .CurrentX = i - 20
        .CurrentY = -bottomabst / 4
        If XUhrzeit Then
            Picture1.Print tabelle(1, index)            ' Beschriftung X-Achse mit Uhrzeit
        Else
            Picture1.Print i / 60                       ' Beschriftung X-Achse mit Stunden
        End If
        index = index + 8                               ' Beschriftung alle 2 Std.
    Next i
End With
Picture1.ForeColor = FCOLOR
End Sub
Private Sub Command2_Click()
' Diagramm zeigen
Dim MaxX As Long
Dim Ystep As Long
Dim XStep As Long
Dim liAbst As Long
Dim reAbst As Long
Dim TopAbst As Long
Dim bottomabst As Long
Dim Dateiname As String
Dim Maxwert As Long
Picture1.Cls
starttime = GetStarttime()      ' Startzeit setzen
Call fillarray                  ' Uhrzeiten in 15 min. Schritten vorgeben
Maxwert = datenlesen()          ' Dateien einlesen und grten Wert ermitteln
If Maxwert = 0 Then             ' keine Daten
    Load Form2                  ' Einstellungen / Dateipfad prfen
    Form2.Show 1
    Exit Sub
End If

If Automatic Then               ' Autom. Y-Skalierung
    MaxY = GetYScale(Maxwert)
End If
MaxX = 24 * 60
Ystep = MaxY / 5
XStep = 120
liAbst = MaxX / 10
reAbst = MaxX / 10
TopAbst = MaxY / 10
bottomabst = MaxY / 5
'Koordinatensystem erstellen
Koordinatensystem MaxX, MaxY, XStep, Ystep, liAbst, reAbst, TopAbst, bottomabst
setpoints bottomabst            ' Diagramm zeichnen

End Sub

Private Sub Command3_Click()
' Einstellungen
Load Form2
Form2.Show 1
Command2_Click      ' Diagramm neu zeichnen
End Sub

Private Sub Form_Load()
Dim Abschnitt As String
Dim Schluessel As String
Dim default As String
Abschnitt = "EINSTELLUNGEN"
Schluessel = "DATEIPFAD"
default = App.Path + "\"
Dateipfad = leseinidatei(Abschnitt, Schluessel, default) ' Dateipfad aus Inidatei
setstandards                ' Standard-Fonteigenschaften zuweisen
Automatic = True            ' Automatische Y-Skala
End Sub
