Attribute VB_Name = "Linien"
Option Explicit

'--------------Types------------
Private Type Point
 X As Long
 Y As Long
End Type

'-------Dateinamen (werden von  >getFileNames< gesetzt)---------------------
Dim File1name As String
Dim File2name As String

'-------Sonstige Daten------------------------------------------------------
Dim startClock As String 'die erste Uhrzeit
Dim lineData(96) As Long 'die Werte

Dim theMax As Long
'-------Andere--------------------------------------------------------------
Dim i As Integer  'Zhlervariable


Private Function getFileNames() As String
  'Diese Funktion wird von Readdata aufgerufen. Es wird das aktuelle Datum
  'gelesen, und die Dateinamen werden daraus erstellt. Auerdem wird die
  'Uhrzeit als Rckgabewert zurckgeliefert.
 Dim fDate1 As String
 Dim fZeit As String
 
  'Datum gestern erfassen
  fDate1 = DateAdd("d", -1, Date)
  'Das Datum korrekt zusammensetzen. (JahrMonatTag)
  File1name = Year(fDate1) & _
              Format(Month(fDate1), "00") & _
              Format(Day(fDate1), "00") & ".txt"
             
  File2name = Year(Date) & _
              Format(Month(Date), "00") & _
              Format(Day(Date), "00") & ".txt"
  
 
fZeit = Format(Hour(Time), "00") & ":" & _
        Format((Minute(Time) - Minute(Time) Mod 15), "00")


'Debug.Print "--------getFilesNames--------"
'Debug.Print "Datei 1:" & File1name
'Debug.Print "Datei 2:" & File2name
'Debug.Print "Zeit :" & fZeit
'Debug.Print "--E-N-D-getFilesNames-E-N-D--"
'-------------------------------
'Beispieldatum verwenden!!!
'File1name = "20040101.txt"
'File2name = "20040102.txt"
'fZeit = frmMain.Text1.Text
'------------------------------ Lschen wenn fertig

getFileNames = fZeit 'rckgeben (Zeit)


End Function
Public Function ReadData() As Boolean
  'Diese Funktion wird von frmMain aus ausgerufen. Sie liest alle Daten
  'in ein Array, die ntig sind, um das Liniendiagramm in gewnschter
  'Form nachher anzuzeigen.
  'Die Dateinamen und Uhrzeit werden von getFileNames geliefert.
 Dim fTime As String
 Dim fTmp As String
 Dim fWert As String
  'das alte lineData() lschen, der Wert -1 beschreibt ein nichtvorhanden
  'sein (im ausschreibungstext steht nix davon, da negative Zahlen
  'im Liniendiagramm vorkommen!)
  For i = 0 To 96
   lineData(i) = -1
  Next i
  
  
  
  fTime = getFileNames  '(getFileNames ist eine eigene Funktion)
  startClock = fTime
  
'Daten lesen --------------------------------
Open App.Path & "\" & File1name For Input As #1  'Datei nr. 1 ffen
'Datum und 2. Zeile sind insgesamt immer 14 Zeichen
'deswegen fangen wir erst bei 15 an zu lesen (fCount)
Line Input #1, fTmp
Line Input #1, fTmp

Open App.Path & "\" & File2name For Input As #2 'Datei nr. 2 ffnen
Line Input #2, fTmp
Line Input #2, fTmp

'Inhalte lesen--------------------------------------------------------
Do Until EOF(1) And EOF(2)
 'Wir lesen in dieser Schleife die erste Datei, also , selbst wenn wir bei
 '0:00 anfangen, mssen wir komplett durchlesen bis zum ende.
 
 '-------------File1---------------------------------------------------
 If Not EOF(1) Then
 
  Line Input #1, fTmp
 
  fTime = Left(fTmp, 5)
  fWert = Right(fTmp, Len(fTmp) - 6)
 
   If fTime >= startClock Then 'wenn die Zeit gltig ist (fr 1. Datei)
    'wir brauchen das Index, in welches wir von lineData schreiben mssen.
    'Dafr bergeben wir startClock, und fTime an die Funktion getlineIndex
    lineData(getLineIndex(startClock, fTime)) = fWert
   End If

 End If
 '--------------------File2-------------------------------------------
 If Not EOF(2) Then 'Dies ist (fast) dasselbe fr Datei nr.2!
  Line Input #2, fTmp 'hier wird allerdings nur gelesen, wenn die Zeit
                      'kleiner als der anfangswert ist.
   fTime = Left(fTmp, 5)
   fWert = Right(fTmp, Len(fTmp) - 6)
   
   If fTime < startClock Then
     lineData(getLineIndex(startClock, fTime)) = fWert
   End If

 End If
Loop
Close #1
Close #2
'--------------------------------------------------------------------------


End Function

Private Function getLineIndex(startTime As String, fTime As String) As Integer
 'Diese Funktion soll den Index einer Uhrzeit fr LineData berechnen.
 Dim result As Integer 'end ergebnis
 
    Dim fTimeH As Integer  'Variablen -> die Stunden & Minuten werden
   Dim fTimeM As Integer  'aus den Uhrzeiten geholt
    Dim startH As Integer
    Dim startM As Integer

fTimeH = Left(fTime, 2)
startH = Left(startTime, 2)
fTimeM = Right(fTime, 2)
startM = Right(startTime, 2)

 result = 0
 
 'wenn die Zeit kleiner ist als die startTime, kann das nur von der 2.
 'Datei kommen. Also rechnen wir einen Tag zu der Uhrzeit dazu (24 stunden)
 If fTime < startTime Then fTimeH = fTimeH + 24 ': GoTo process
 
    
 'wir subtrahieren die Minuten voneinander, wenn die Minuten dann im
 '- Bereich sind, addieren wir wieder 60 , und ziehen dafr eine Stunde ab.
   fTimeM = fTimeM - startM
   If fTimeM < 0 Then fTimeM = fTimeM + 60: fTimeH = fTimeH - 1
   
   'Der Index luft von 1 (startZeit) bis 96.
    'in jeder stunde sind 4 x 15 minuten, fr diese wird jeweils 1 Index
    'genutzt.
   result = fTimeM / 15
   
   fTimeH = fTimeH - startH 'Stunden subtrahieren.
                           'dessen Ergebnis ist nie im Minusbereich,
                           'weil vorher 24 Stunden addiert werden, wenn
                           'es ntig wre.
   
   result = result + (fTimeH * 4) + 1 'Unser Index beginnt bei 1.
    
getLineIndex = result
End Function

Private Function YScale(maxWert As Long) As Integer
 'Der Rckgabe wert ist, wieviel eine Einheit, ( 40 Pixel) sind.
 'PicDiagramm.Height => 337
 'alle 26 Pixel 1 Stunde
 maxWert = maxWert + 500
 frmMain.ScaleMode = 3
YScale = (maxWert / 8) - ((maxWert / 8) Mod 50)
theMax = maxWert / 320 * 323
'MsgBox theMax

End Function

Private Sub ShowGrid(control As PictureBox, hourStep As Integer)
 'Zeichne das Gitter...
 control.ScaleMode = 3
 control.Cls
 
 For i = 1 To 24
  control.Line (i * hourStep + 25 + (hourStep / 4), 0)-(i * hourStep + 25 + (hourStep / 4), 323), "&hBBBBBB"
 Next i
 For i = 0 To 8
  control.Line (30, 323 - (i * 40))-(24 * 26 + 30, 323 - (i * 40)), "&hBBBBBB"
 Next i
End Sub
Private Sub showValues(YScaling As Long, control As PictureBox, hourStep As Integer)
control.FontName = "Times New Roman"
control.FontSize = 10

 For i = 0 To 8
  'zahlen dranschreiben (von der angepassten Gre, fr Y-Achse)
  control.CurrentX = 4
  control.CurrentY = 323 - (i * 40) - 6
  control.ForeColor = "&HFF0000"
  control.Print YScaling * i
 Next i
 
Dim printTime As String
Dim stH As Integer
Dim stM As Integer
 
 For i = 1 To 24 Step 2
 'zahlen dranschreiben (von den Uhrzeiten)
  control.CurrentX = (i * hourStep + 25) + (hourStep / 4) - (control.TextWidth(stH - 1 & ":" & stM) / 2)
  control.CurrentY = 323
  control.ForeColor = "&H007700"
  
  stH = Left(startClock, 2)
  stM = Right(startClock, 2)

  stH = stH + i + 1
  If stH > 24 Then stH = stH - 24: control.ForeColor = "&H004000"
  control.Print stH - 1 & ":" & stM
 Next i

control.CurrentX = 5
control.CurrentY = 340
control.FontName = "Fixedsys"

control.ForeColor = "&H007700"
control.Print DateAdd("d", -1, Date);

control.ForeColor = "&H004000"
control.CurrentX = control.Width - control.TextWidth(Date) - 5
control.Print Date

End Sub

Public Sub ShowData(max As Long, control As PictureBox, hourStep As Integer)
Dim Pdat(96) As Point
'feld lschen
For i = 1 To 96
   
   Pdat(i).X = ((i \ 4) * hourStep + 25) + ((hourStep / 4) * (i Mod 4)) '- (hourStep / 4))
   
   Pdat(i).Y = 320 - ((lineData(i) / max) * 323)
   
  If lineData(i) <> -1 Then control.PSet (Pdat(i).X, Pdat(i).Y)
 
 If lineData(i) = -1 Then Pdat(i).X = -1: Pdat(i).Y = -1
 
Next i

For i = 1 To 95
 
 If lineData(i) <> -1 And lineData(i + 1) <> -1 Then
   control.Line (Pdat(i).X, Pdat(i).Y)-(Pdat(i + 1).X, Pdat(i + 1).Y)
 End If
 
Next i

End Sub

Public Sub ShowAll()
 'Grid , Values und Data anzeigen
  Dim highest As Long
  highest = 0
  For i = 1 To 96
   If lineData(i) > highest Then highest = lineData(i)
  Next i
  
  ShowGrid frmMain.picDiagramm, 26
  showValues YScale(highest), frmMain.picDiagramm, 26
  ShowData theMax, frmMain.picDiagramm, 26
End Sub
