VERSION 5.00
Begin VB.Form frmFarben 
   BorderStyle     =   4  'Festes Werkzeugfenster
   Caption         =   "Farben whlen"
   ClientHeight    =   3090
   ClientLeft      =   45
   ClientTop       =   315
   ClientWidth     =   6360
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   3090
   ScaleWidth      =   6360
   ShowInTaskbar   =   0   'False
   StartUpPosition =   3  'Windows-Standard
   Begin VB.ListBox listEigenschaften 
      Height          =   1230
      ItemData        =   "frmFarben.frx":0000
      Left            =   360
      List            =   "frmFarben.frx":0016
      TabIndex        =   4
      Top             =   600
      Width           =   2055
   End
   Begin VB.HScrollBar Blau 
      Height          =   255
      LargeChange     =   10
      Left            =   3240
      Max             =   255
      TabIndex        =   3
      Top             =   1920
      Width           =   2535
   End
   Begin VB.HScrollBar Gruen 
      Height          =   255
      LargeChange     =   10
      Left            =   3240
      Max             =   255
      TabIndex        =   2
      Top             =   1560
      Width           =   2535
   End
   Begin VB.HScrollBar Rot 
      Height          =   255
      LargeChange     =   10
      Left            =   3240
      Max             =   255
      TabIndex        =   1
      Top             =   1200
      Width           =   2535
   End
   Begin VB.CommandButton cmdOK 
      Caption         =   "OK"
      Height          =   375
      Left            =   2280
      TabIndex        =   0
      Top             =   2520
      Width           =   1815
   End
   Begin VB.Shape Farbe 
      BackColor       =   &H00000000&
      BackStyle       =   1  'Undurchsichtig
      BorderStyle     =   0  'Transparent
      Height          =   975
      Left            =   3840
      Shape           =   3  'Kreis
      Top             =   120
      Width           =   975
   End
   Begin VB.Shape Shape1 
      BackColor       =   &H00FF0000&
      BackStyle       =   1  'Undurchsichtig
      BorderStyle     =   0  'Transparent
      Height          =   255
      Index           =   2
      Left            =   2880
      Shape           =   3  'Kreis
      Top             =   1920
      Width           =   255
   End
   Begin VB.Shape Shape1 
      BackColor       =   &H0000FF00&
      BackStyle       =   1  'Undurchsichtig
      BorderStyle     =   0  'Transparent
      Height          =   255
      Index           =   1
      Left            =   2880
      Shape           =   3  'Kreis
      Top             =   1560
      Width           =   255
   End
   Begin VB.Shape Shape1 
      BackColor       =   &H000000FF&
      BackStyle       =   1  'Undurchsichtig
      BorderStyle     =   0  'Transparent
      Height          =   255
      Index           =   0
      Left            =   2880
      Shape           =   3  'Kreis
      Top             =   1200
      Width           =   255
   End
End
Attribute VB_Name = "frmFarben"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

'In dieser Form lassen sich die Farben des Diagramms anpassen
'frmMain.Diagramm ist public, d.h. von hieraus kann darauf zugegriffen werden

' * * * Auswahl einer Eigenschaft * * *
Private Sub listEigenschaften_Click()
'Aus der List-Box muss eine der 6 Eigenschaften gewhlt werden

  Dim lFarbe As Long    'Die Farbe der gewhlten Eigenschaft
  
    'Welche Eigenschaft wurde gewhlt?
    Select Case listEigenschaften.ListIndex
      Case 0:       'Graph
        lFarbe = frmMain.Diagramm.lGraphColor
      Case 1:       'Vertikale Linien
        lFarbe = frmMain.Diagramm.lScaleXLinesColor
      Case 2:       'Vertikale Beschriftung
        lFarbe = frmMain.Diagramm.lScaleXValuesColor
      Case 3:       'Horizontale Linien
        lFarbe = frmMain.Diagramm.lScaleYLinesColor
      Case 4:       'Horizontale Beschriftung
        lFarbe = frmMain.Diagramm.lScaleYValuesColor
      Case 5:       'Hintergrund
        lFarbe = frmMain.Diagramm.lBackgroundColor
    End Select
    
    'In R, G, B - Werte Aufsplitten
    Rot.Value = lFarbe And 255
    Gruen.Value = (lFarbe And 65280) / 256
    Blau.Value = (lFarbe And 16711680) / 65536
    'Die entsprechenden Werte werden dann auf den 3 Scrollbars dargsetellt
End Sub

' * * * Farbe ndern * * *
Private Sub FarbeAendern()

    'Vorschau der Farbe
    Farbe.BackColor = RGB(Rot.Value, Gruen.Value, Blau.Value)
    
    'Welche Eigenschaft wurde gewhlt?
    Select Case listEigenschaften.ListIndex
      Case 0:       'Graph
        frmMain.Diagramm.lGraphColor = RGB(Rot.Value, Gruen.Value, Blau.Value)
      Case 1:       'Vertikale Linien
        frmMain.Diagramm.lScaleXLinesColor = RGB(Rot.Value, Gruen.Value, Blau.Value)
      Case 2:       'Vertikale Beschriftung
        frmMain.Diagramm.lScaleXValuesColor = RGB(Rot.Value, Gruen.Value, Blau.Value)
      Case 3:       'Horizontale Linien
        frmMain.Diagramm.lScaleYLinesColor = RGB(Rot.Value, Gruen.Value, Blau.Value)
      Case 4:       'Horizontale Beschriftung
        frmMain.Diagramm.lScaleYValuesColor = RGB(Rot.Value, Gruen.Value, Blau.Value)
      Case 5:       'Hintergrund
        frmMain.Diagramm.lBackgroundColor = RGB(Rot.Value, Gruen.Value, Blau.Value)
    End Select
    
    'Diagramm neu zeichnen
    frmMain.Diagramm.DrawDiagram False
End Sub

' * * * Beim scrollen einer Scrollbar ist gleich das Resultat im Diagramm sichtbar * * *
Private Sub Rot_Change()
    FarbeAendern
End Sub
Private Sub Rot_Scroll()
    FarbeAendern
End Sub
Private Sub Blau_Change()
    FarbeAendern
End Sub
Private Sub Blau_Scroll()
    FarbeAendern
End Sub
Private Sub Gruen_Change()
    FarbeAendern
End Sub
Private Sub Gruen_Scroll()
    FarbeAendern
End Sub

' * * * Fenster schlieen * * *
Private Sub cmdOK_Click()
    Unload Me
End Sub


