Attribute VB_Name = "modFolder"
Option Explicit

' Konstanten fr Startverzeichnis
Public Const CSIDL_DESKTOP = &H0
Public Const CSIDL_PROGRAMS = &H2
Public Const CSIDL_CONTROLS = &H3
Public Const CSIDL_PRINTERS = &H4
Public Const CSIDL_PERSONAL = &H5
Public Const CSIDL_FAVORITES = &H6
Public Const CSIDL_STARTUP = &H7
Public Const CSIDL_RECENT = &H8
Public Const CSIDL_SENDTO = &H9
Public Const CSIDL_BITBUCKET = &HA
Public Const CSIDL_STARTMENU = &HB
Public Const CSIDL_DESKTOPDIRECTORY = &H10
Public Const CSIDL_DRIVES = &H11
Public Const CSIDL_NETWORK = &H12
Public Const CSIDL_NETHOOD = &H13
Public Const CSIDL_FONTS = &H14
Public Const CSIDL_TEMPLATES = &H15

'sonstige Konstanten und Deklarationen

Public Const BIF_RETURNONLYFSDIRS = &H1

Public Type BROWSEINFO
    hOwner As Long
    pidlRoot As Long
    pszDisplayName As String
    lpszTitle As String
    ulFlags As Long
    lpfn As Long
    lParam As Long
    iImage As Long
End Type

Public Declare Function SHBrowseForFolder _
    Lib "shell32.dll" Alias "SHBrowseForFolderA" _
    (lpBrowseInfo As BROWSEINFO) As Long

Public Declare Function SHGetPathFromIDList _
    Lib "shell32.dll" Alias "SHGetPathFromIDListA" _
    (ByVal pidl As Long, ByVal pszPath As String) As Long


Public Function GetFolder _
    (Hwnd As Long, _
    DialogTitle As String, _
    IDRoot As Long) As String

    Dim Ret As Boolean
    Dim pidl As Long
    Dim Folder As String
    Dim BrInfo As BROWSEINFO

    With BrInfo
        .hOwner = Hwnd
        .pidlRoot = IDRoot
        .lpszTitle = DialogTitle
        .ulFlags = BIF_RETURNONLYFSDIRS
    End With

    'Dialog fr Ordnerauswahl zeigen
    pidl = SHBrowseForFolder(BrInfo)
    'falls SHBrowseForFolder() abgebrochen wurde ist pidl = 0

    'Variable Folder mit ausreichend langem Leerstring vorbelegen
    Folder = String$(512, 0)
    Ret = SHGetPathFromIDList(ByVal pidl, ByVal Folder)
    'Ret = 0, wenn pidl = 0 war

    If Ret Then
        GetFolder = Left(Folder, InStr(Folder, Chr$(0)) - 1)
    Else
        GetFolder = ""
    End If
End Function






