VERSION 5.00
Begin VB.UserControl ctlLineDiagram 
   BackColor       =   &H80000000&
   ClientHeight    =   2880
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   3840
   ScaleHeight     =   2880
   ScaleWidth      =   3840
   Begin VB.PictureBox Picture1 
      Appearance      =   0  '2D
      AutoRedraw      =   -1  'True
      BackColor       =   &H80000005&
      BorderStyle     =   0  'Kein
      ForeColor       =   &H80000008&
      Height          =   2292
      Left            =   240
      ScaleHeight     =   191
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   271
      TabIndex        =   0
      Top             =   240
      Width           =   3252
      Begin VB.Line Line1 
         BorderColor     =   &H0080FF80&
         Index           =   0
         Visible         =   0   'False
         X1              =   60
         X2              =   60
         Y1              =   80
         Y2              =   120
      End
      Begin VB.Line Line1 
         BorderColor     =   &H0080FF80&
         Index           =   1
         Visible         =   0   'False
         X1              =   120
         X2              =   210
         Y1              =   60
         Y2              =   60
      End
   End
End
Attribute VB_Name = "ctlLineDiagram"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
Private Declare Function SetCapture Lib "user32" (ByVal Hwnd As Long) As Long
Private Declare Function ReleaseCapture Lib "user32" () As Long
Private Declare Function GetCapture Lib "user32" () As Long
Private Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (Destination As Any, Source As Any, ByVal Length As Long)

'Standard-Eigenschaftswerte:
Const m_def_Endzeitpunkt = "00:00"
Const m_def_FarbeHintergrund = vbWhite
Const m_def_FarbeFadenkreuz = vbGreen
Const m_def_FarbeHilfslinien = vbBlack
Const m_def_FarbeLinie = vbBlack
Const m_def_FarbeNummern = vbBlack
Const m_def_Hilfslinien = True
Const m_def_AutoScale = True
Const m_def_Fadenkreuz = False
Const m_def_FarbeScalierung = vbBlack
Const m_def_ScalierungZeit = 1
Const m_def_ScalierungWert = 20000
Const m_def_DiaEndWert = 100000

'Enums
Public Enum ScalZVars
ZweiStunden = 1
EineStunde = 2
HalbeStunde = 3
ViertelStunde = 4
End Enum
'Eigenschaftsvariablen:
Dim m_DiaEndWert As Long
Dim m_ScalierungZeit As ScalZVars
Dim m_ScalierungWert As Long
Dim m_Endzeitpunkt As String
Dim m_FarbeHintergrund As OLE_COLOR
Dim m_FarbeFadenkreuz As OLE_COLOR
Dim m_FarbeHilfslinien As OLE_COLOR
Dim m_FarbeLinie As OLE_COLOR
Dim m_FarbeNummern As OLE_COLOR
Dim m_Hilfslinien As Boolean
Dim m_AutoScale As Boolean
Dim m_Fadenkreuz As Boolean
Dim m_FarbeScalierung As OLE_COLOR
Dim WerteTag1() As Long
Dim WerteTag2() As Long
Dim X_Achse() As Long
Dim Y_Achse() As Long
Dim WertearrayFertig() As Long
Dim Zeitarray() As String
Dim AktHchstwert As Long
Dim reagierenicht As Integer
Dim Resizen1 As Boolean
Dim Resizen2 As Boolean
Dim Aktendwert As Long
Dim AktScalewert As Long

Public Property Get DiaEndWert() As Long
Attribute DiaEndWert.VB_Description = "Hchswert des Diagramms - bitte 10/100 /500/2000 oder hnliche Werte eingeben"
    DiaEndWert = m_DiaEndWert
End Property

Public Property Let DiaEndWert(ByVal New_DiaEndWert As Long) 'Hchster Wert im Diagramm
    Dim test As Long
    Dim Alterwert As Long
    Dim Testlong As Long
    Dim bergabe As Long
    
    Alterwert = m_DiaEndWert
    Aktendwert = New_DiaEndWert
    bergabe = AktHchstwert
    If New_DiaEndWert >= AktHchstwert Then 'Nur Falls neuer Endwert grer als Hchstwert der Daten
    AktHchstwert = New_DiaEndWert
    AktScalewert = SucheAHScalierung(Testlong)
    test = New_DiaEndWert \ AktScalewert
    AutoScale = False
    reagierenicht = 1
    If test <= 100 Then 'zur Absicherung nur bis zu 100 Scalierungslinien zugelassen
    AktHchstwert = New_DiaEndWert
    ScalierungWert = SucheAHScalierung(Testlong)
    End If
    m_DiaEndWert = New_DiaEndWert
    If reagierenicht = 0 Then
    UserControl.Refresh
    End If
    PropertyChanged "DiaEndWert"
    End If
    AktHchstwert = m_DiaEndWert
    reagierenicht = 0
End Property

Public Property Get ScalierungWert() As Long 'Scalierung Wertelinie
Attribute ScalierungWert.VB_Description = "Scalierungsgre Wertachse"
    ScalierungWert = m_ScalierungWert
End Property

Public Property Let ScalierungWert(ByVal New_ScalierungWert As Long)
Dim test As Long
If DiaEndWert Mod New_ScalierungWert = 0 Then
If New_ScalierungWert <= DiaEndWert Then 'nur wenn grer als Endwert
test = Aktendwert \ New_ScalierungWert
If test <= 100 Then 'zur Absicherung nur bis zu 100 Scalierungslinien zugelassen
    m_ScalierungWert = New_ScalierungWert
    If reagierenicht = 0 Then
    AktScalewert = New_ScalierungWert
    UserControl.Refresh
    PropertyChanged "ScalierungWert"
    Else
    reagierenicht = 0
    End If
End If
End If
AktScalewert = ScalierungWert
End If
End Property

Public Property Get ScalierungZeit() As ScalZVars
Attribute ScalierungZeit.VB_Description = "Scalierung Zeitachse (Endwert mu durch diesen Wert teilbar sein!!!)"
    ScalierungZeit = m_ScalierungZeit
End Property

Public Property Let ScalierungZeit(ByVal New_ScalierungZeit As ScalZVars)
    m_ScalierungZeit = New_ScalierungZeit
    UserControl.Refresh
    PropertyChanged "ScalierungZeit"
End Property

Public Property Get Endzeitpunkt() As String
Attribute Endzeitpunkt.VB_Description = "End- (Anfangs-)zeit des Diagramms"
Attribute Endzeitpunkt.VB_MemberFlags = "400"
    Endzeitpunkt = m_Endzeitpunkt
End Property

Public Property Let Endzeitpunkt(ByVal New_Endzeitpunkt As String)
Dim test As String
Dim Wo As Long
Dim Lnge As Integer
Dim Wo1 As Long
Dim testen As Boolean
Dim teststring1 As String
Dim teststring2 As String
Dim testint1 As Integer
Dim testint2 As Integer
Lnge = Len(New_Endzeitpunkt)
If Lnge >= 1 And Lnge <= 5 Then 'Fehlerberprfung
    Wo = InStr(New_Endzeitpunkt, ":")
        test = Replace(New_Endzeitpunkt, ":", "")
    If Wo + 1 <= Lnge Then Wo1 = InStr(Wo + 1, New_Endzeitpunkt, ":")
If Wo > 1 And Lnge - Wo <= 2 Then testen = True

If Wo <> 0 And Wo < Lnge And Wo1 = 0 And IsNumeric(test) = True And testen = True Then
    If Wo = 2 Then New_Endzeitpunkt = "0" & New_Endzeitpunkt
    If Len(New_Endzeitpunkt) = 3 Then New_Endzeitpunkt = New_Endzeitpunkt & "00"
    If Len(New_Endzeitpunkt) = 4 Then New_Endzeitpunkt = New_Endzeitpunkt & "0"
    teststring1 = Left(New_Endzeitpunkt, 2)
    teststring2 = Mid(New_Endzeitpunkt, 4, 2)
    If IsNumeric(teststring1) And IsNumeric(teststring2) Then
    testint1 = CInt(teststring1)
    testint2 = CInt(teststring2)
    If testint1 < 24 And testint1 >= 0 And testint2 < 60 And testint2 >= 0 Then
    m_Endzeitpunkt = New_Endzeitpunkt
    UserControl.Refresh
    PropertyChanged "Endzeitpunkt"
    End If
    End If
    Else
If IsNumeric(New_Endzeitpunkt) Then 'nur Nummern
If New_Endzeitpunkt <= 23 Then
    New_Endzeitpunkt = New_Endzeitpunkt & ":" & "00"
    If Len(New_Endzeitpunkt) < 5 Then New_Endzeitpunkt = "0" & New_Endzeitpunkt
    m_Endzeitpunkt = New_Endzeitpunkt
    UserControl.Refresh
    PropertyChanged "Endzeitpunkt"
End If
End If
End If
End If
End Property
Public Property Get FarbeHintergrund() As OLE_COLOR
Attribute FarbeHintergrund.VB_Description = "Farbe des Diagrammhintergrundes"
    FarbeHintergrund = m_FarbeHintergrund
End Property

Public Property Let FarbeHintergrund(ByVal New_FarbeHintergrund As OLE_COLOR)
    m_FarbeHintergrund = New_FarbeHintergrund
        UserControl.Refresh
    PropertyChanged "FarbeHintergrund"
End Property

Public Property Get FarbeFadenkreuz() As OLE_COLOR
Attribute FarbeFadenkreuz.VB_Description = "Farbe des Fadenkreuzes"
    FarbeFadenkreuz = m_FarbeFadenkreuz
End Property

Public Property Let FarbeFadenkreuz(ByVal New_FarbeFadenkreuz As OLE_COLOR)
    m_FarbeFadenkreuz = New_FarbeFadenkreuz
    Line1(0).BorderColor = m_FarbeFadenkreuz
    Line1(1).BorderColor = m_FarbeFadenkreuz
    PropertyChanged "FarbeFadenkreuz"
End Property
Public Property Get FarbeLinie() As OLE_COLOR
Attribute FarbeLinie.VB_Description = "Farbe der Diagrammlinie"
    FarbeLinie = m_FarbeLinie
End Property

Public Property Let FarbeLinie(ByVal New_FarbeLinie As OLE_COLOR)
    m_FarbeLinie = New_FarbeLinie
    UserControl.Refresh
    PropertyChanged "FarbeLinie"
End Property
Public Property Get FarbeNummern() As OLE_COLOR
Attribute FarbeNummern.VB_Description = "Farbe der Nummern (Zeit- und Wertachse)"
    FarbeNummern = m_FarbeNummern
End Property

Public Property Let FarbeNummern(ByVal New_FarbeNummern As OLE_COLOR)
    m_FarbeNummern = New_FarbeNummern
    UserControl.Refresh
    PropertyChanged "FarbeNummern"
End Property


Public Property Get FarbeHilfslinien() As OLE_COLOR
Attribute FarbeHilfslinien.VB_Description = "Farbe der horizontalen Hilfslinien"
    FarbeHilfslinien = m_FarbeHilfslinien
End Property

Public Property Let FarbeHilfslinien(ByVal New_FarbeHilfslinien As OLE_COLOR)
    m_FarbeHilfslinien = New_FarbeHilfslinien
    UserControl.Refresh
    PropertyChanged "FarbeHilfslinien"
End Property
Public Property Get AutoScale() As Boolean
Attribute AutoScale.VB_Description = "Automatisches Skalieren"
    AutoScale = m_AutoScale
End Property

Public Property Let AutoScale(ByVal New_AutoScale As Boolean)
    If New_AutoScale <> m_AutoScale Then
    m_AutoScale = New_AutoScale
    UserControl.Refresh
    PropertyChanged "AutoScale"
    End If
End Property

Public Property Get Hilfslinien() As Boolean
Attribute Hilfslinien.VB_Description = "horizontale Hilfslinien ja/nein"
    Hilfslinien = m_Hilfslinien
End Property

Public Property Let Hilfslinien(ByVal New_Hilfslinien As Boolean)
    m_Hilfslinien = New_Hilfslinien
    UserControl.Refresh
    PropertyChanged "Hilfslinien"
End Property

Public Property Get Fadenkreuz() As Boolean
Attribute Fadenkreuz.VB_Description = "Hilfswerkzeug Fadenkreuz ja/nein"
    Fadenkreuz = m_Fadenkreuz
End Property

Public Property Let Fadenkreuz(ByVal New_Fadenkreuz As Boolean)
    m_Fadenkreuz = New_Fadenkreuz
    PropertyChanged "Fadenkreuz"
End Property

Public Property Get FarbeScalierung() As OLE_COLOR
Attribute FarbeScalierung.VB_Description = "Farbe der Scalierungslinien"
    FarbeScalierung = m_FarbeScalierung
End Property

Public Property Let FarbeScalierung(ByVal New_FarbeScalierung As OLE_COLOR)
    m_FarbeScalierung = New_FarbeScalierung
    UserControl.Refresh
    PropertyChanged "FarbeScalierung"
End Property

Private Sub UserControl_Initialize()
ReDim WerteTag1(95) 'Werte mit 0 initialisieren (sonst Fehler beim zeichnen)
ReDim WerteTag2(95)
End Sub

'Eigenschaften fr Benutzersteuerelement initialisieren
Private Sub UserControl_InitProperties()
    m_AutoScale = m_def_AutoScale
    m_Endzeitpunkt = m_def_Endzeitpunkt
    m_FarbeHintergrund = m_def_FarbeHintergrund
    m_FarbeFadenkreuz = m_def_FarbeFadenkreuz
    m_FarbeHilfslinien = m_def_FarbeHilfslinien
    m_FarbeLinie = m_def_FarbeLinie
    m_FarbeNummern = m_def_FarbeNummern
    m_Hilfslinien = m_def_Hilfslinien
    m_Fadenkreuz = m_def_Fadenkreuz
    m_FarbeScalierung = m_def_FarbeScalierung
    m_ScalierungZeit = m_def_ScalierungZeit
    m_ScalierungWert = m_def_ScalierungWert
    m_DiaEndWert = m_def_DiaEndWert
End Sub

'Eigenschaftenwerte vom Speicher laden
Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
    m_AutoScale = PropBag.ReadProperty("AutoScale", m_def_AutoScale)
    m_DiaEndWert = PropBag.ReadProperty("DiaEndWert", m_def_DiaEndWert)
    m_ScalierungWert = PropBag.ReadProperty("ScalierungWert", m_def_ScalierungWert)
    m_ScalierungZeit = PropBag.ReadProperty("ScalierungZeit", m_def_ScalierungZeit)
    m_Endzeitpunkt = PropBag.ReadProperty("Endzeitpunkt", m_def_Endzeitpunkt)
    m_FarbeHintergrund = PropBag.ReadProperty("FarbeHintergrund", m_def_FarbeHintergrund)
    m_FarbeFadenkreuz = PropBag.ReadProperty("FarbeFadenkreuz", m_def_FarbeFadenkreuz)
    m_FarbeHilfslinien = PropBag.ReadProperty("FarbeHilfslinien", m_def_FarbeHilfslinien)
    m_FarbeLinie = PropBag.ReadProperty("FarbeLinie", m_def_FarbeLinie)
    m_FarbeNummern = PropBag.ReadProperty("FarbeNummern", m_def_FarbeNummern)
    m_Hilfslinien = PropBag.ReadProperty("Hilfslinien", m_def_Hilfslinien)
    m_Fadenkreuz = PropBag.ReadProperty("Fadenkreuz", m_def_Fadenkreuz)
    m_FarbeScalierung = PropBag.ReadProperty("FarbeScalierung", m_def_FarbeScalierung)
End Sub


Private Sub UserControl_Resize()

Dim Hilfslong As Long
If UserControl.Height < 2000 Then 'Mindestgre
Resizen2 = True
UserControl.Height = 2000
Picture1.Height = 1700
End If
If UserControl.Width < 3000 And Resizen1 = False Then
Resizen1 = True
UserControl.Width = 3000
Picture1.Width = 2400
End If
Picture1.Height = UserControl.Height - 800
Picture1.Width = UserControl.Width - 800 'Controls ausrichten
If Picture1.ScaleWidth Mod 96 <> 0 Then 'zur saubereren Darstellung
Hilfslong = Picture1.ScaleWidth \ 96
Hilfslong = Hilfslong * 96
Picture1.ScaleWidth = Hilfslong
End If
'Picture1.Height = UserControl.Height - 800
If Picture1.Height + 200 > UserControl.Height Then
UserControl.Height = Picture1.Height + 200
End If

Resizen1 = False
Resizen2 = False
End Sub

'Eigenschaftenwerte in den Speicher schreiben
Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
    Call PropBag.WriteProperty("AutoScale", m_AutoScale, m_def_AutoScale)
    Call PropBag.WriteProperty("DiaEndWert", m_DiaEndWert, m_def_DiaEndWert)
    Call PropBag.WriteProperty("ScalierungWert", m_ScalierungWert, m_def_ScalierungWert)
    Call PropBag.WriteProperty("ScalierungZeit", m_ScalierungZeit, m_def_ScalierungZeit)
    Call PropBag.WriteProperty("Endzeitpunkt", m_Endzeitpunkt, m_def_Endzeitpunkt)
    Call PropBag.WriteProperty("FarbeHintergrund", m_FarbeHintergrund, m_def_FarbeHintergrund)
    Call PropBag.WriteProperty("FarbeFadenkreuz", m_FarbeFadenkreuz, m_def_FarbeFadenkreuz)
    Call PropBag.WriteProperty("FarbeHilfslinien", m_FarbeHilfslinien, m_def_FarbeHilfslinien)
    Call PropBag.WriteProperty("FarbeLinie", m_FarbeLinie, m_def_FarbeLinie)
    Call PropBag.WriteProperty("FarbeNummern", m_FarbeNummern, m_def_FarbeNummern)
    Call PropBag.WriteProperty("Hilfslinien", m_Hilfslinien, m_def_Hilfslinien)
    Call PropBag.WriteProperty("Fadenkreuz", m_Fadenkreuz, m_def_Fadenkreuz)
    Call PropBag.WriteProperty("FarbeScalierung", m_FarbeScalierung, m_def_FarbeScalierung)
End Sub


Private Sub Picture1_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
      If GetCapture <> Picture1.Hwnd Then 'Mausbewegung einfangen
                SetCapture Picture1.Hwnd
                Call MouseIn
            End If
    
    If X < 0 Or X > Picture1.ScaleWidth Or Y < 0 Or Y > Picture1.ScaleHeight Then
        ReleaseCapture 'Maus nicht auf Picturebox
        Call MouseOut
    End If
  Line1(1).X1 = 0 'Fadenkreuz ausrichten
  Line1(1).X2 = Picture1.Width
  Line1(1).Y1 = Y
  Line1(1).Y2 = Y
  
  Line1(0).Y1 = 0
  Line1(0).Y2 = Picture1.Height
  Line1(0).X1 = X
  Line1(0).X2 = X
  
  Line1(0).Refresh
  Line1(1).Refresh

End Sub

Private Sub UserControl_Paint()
    Picture1.BackColor = m_FarbeHintergrund
    Line1(0).BorderColor = m_FarbeFadenkreuz
    Line1(1).BorderColor = m_FarbeFadenkreuz
    ErstelleDiagramm 'Neu zeichnen
End Sub
Private Sub MouseIn() 'Maus auf Diagramm
If Fadenkreuz = True Then 'Fadenkreuz sichtbar/unsichtbar
  Line1(0).Visible = True
  Line1(1).Visible = True
  Else
  Line1(0).Visible = False
  Line1(1).Visible = False
End If
End Sub

Private Sub MouseOut() 'Maus nicht auf Diagramm
  Line1(0).Visible = False 'Fadenkreuz unsichtbar
  Line1(1).Visible = False
End Sub


Private Sub ErstelleOberflche() 'Grundoberflche zeichnen
Dim Hilfslong As Long
Dim Berechnung1 As Long
Dim Berechnung2 As Long
Dim Rechentest1 As Long
Dim Rechentest2 As Long
Dim Testlong As Long
Dim Testlong1 As Long
Dim Hoch As Long
Dim Lnge As Long
Dim i As Long
If AktScalewert = 0 Then AktScalewert = ScalierungWert
If DiaEndWert Mod ScalierungWert = 0 Then 'beste Hhe berechnen (ist noch nicht ausgereift - bei Verbesserungsvorschlgen bitte an mich wenden!!)
Hilfslong = DiaEndWert \ ScalierungWert
Else
Hilfslong = (DiaEndWert \ ScalierungWert) + 1
End If
If Hilfslong > Picture1.ScaleHeight Then
Testlong1 = SucheAHScalierung(Hoch)
AktScalewert = Testlong1
ScalierungWert = Testlong1
End If
If Picture1.ScaleHeight Mod Hilfslong = 0 Then
Else
Testlong = Picture1.ScaleHeight \ Hilfslong
If Testlong > 0 Then
Berechnung1 = Testlong * Hilfslong 'kleiner
Testlong = Testlong + 1
Berechnung2 = Testlong * Hilfslong 'grer
Testlong = Testlong * Hilfslong
Rechentest1 = Picture1.Height - (Berechnung1 * Screen.TwipsPerPixelY) 'kleiner
Rechentest2 = Picture1.Height - Berechnung2 * (Screen.TwipsPerPixelY) 'grer
If Abs(Rechentest1) < Abs(Rechentest2) Then
Picture1.Height = Berechnung1 * Screen.TwipsPerPixelY
Else
Picture1.Height = Berechnung2 * Screen.TwipsPerPixelY
End If
End If
End If
Lnge = Picture1.Width
Picture1.Move (UserControl.Width - Picture1.Width - 100), (UserControl.Height - Picture1.Height) / 2 - 100
End Sub

Private Sub ErstelleDiagramm()
Dim Ausgleich As Long
Dim Hilfslong As Long
Dim Hhenwert As Long
Dim Skalierungsschritt As Long
Dim i As Long
Dim Testlong As Long
Dim Zeitachse As Integer
Dim Beschriftung As String
Dim Anfangszeitpunkt As String
Dim Startindexnummer As Integer
Dim Anfangsstunde As Integer
Dim Anfangsminute As Integer
Dim Schrittweite As Long
Dim SchrittGerade As Long
Dim Zhler As Long
Dim AktScalSchritt As Long
Dim Picturepunkt As Long
Picture1.Cls
Anfangszeitpunkt = Endzeitpunkt 'Anfang = gleiche Zeit 1 Tag vorher
Anfangsstunde = CInt(Left(Anfangszeitpunkt, 2))
Anfangsminute = CInt(Mid(Anfangszeitpunkt, 4, 2))
Startindexnummer = (Anfangsstunde * 4) + (Anfangsminute / 15) 'Indexnummer der Startzeit
ErstelleZeitarray Anfangsstunde, Anfangsminute, Startindexnummer
ErstelleOberflche
WertearrayErstellen Startindexnummer
Hhenwert = DiaEndWert 'Positionen fr Horizontale Linien berechnen
Skalierungsschritt = AktScalewert
Schrittweite = BerechneWerty(Hhenwert, Skalierungsschritt, Picture1.ScaleHeight)
AktScalSchritt = Skalierungsschritt
'Horizontale Hilfslinien zeichnen
Picture1.DrawStyle = 0
SchrittGerade = 0
Picture1.ForeColor = m_FarbeHilfslinien
For i = 0 To Picture1.ScaleHeight Step Schrittweite
If Hilfslinien = True Then  'wenn mit Horizontalen Linien
Picture1.Line (0, Picture1.ScaleHeight - i)-(Picture1.ScaleWidth, Picture1.ScaleHeight - i)
End If
UserControl.ForeColor = m_FarbeScalierung
UserControl.Line (Picture1.Left - 150, Picture1.Height + Picture1.Top - (i * Screen.TwipsPerPixelY))-(Picture1.Left, Picture1.Height + Picture1.Top - (i * Screen.TwipsPerPixelY))
UserControl.CurrentX = Picture1.Left - 200 - UserControl.TextWidth(CStr(SchrittGerade))
UserControl.CurrentY = Picture1.Height + Picture1.Top - (i * Screen.TwipsPerPixelY) - (UserControl.TextHeight("00") \ 2)
UserControl.ForeColor = m_FarbeNummern
UserControl.Print SchrittGerade
SchrittGerade = SchrittGerade + Skalierungsschritt
Next i
Ausgleich = Picture1.ScaleHeight - (i - Schrittweite) 'da oberste Linie nicht Hhe Picturebox
'Hhenwert = SchrittGerade - Skalierungsschritt
i = 0
'Scalierung Zeit-Achse zeichnen und Beschriftung ausgeben
UserControl.ForeColor = m_FarbeScalierung
For Zhler = 0 To 96 '24 Stunden - jede Viertelstunde
Select Case ScalierungZeit
Case 1 'alle 2 Stunden Scala
If Mid(Zeitarray(Zhler), 4, 2) = "00" Then 'jede volle Stunde
Testlong = CLng(Mid(Zeitarray(Zhler), 1, 2))
If Testlong Mod 2 = 0 Then ' jede 2. Stunde
UserControl.Line (Picture1.Left + i, Picture1.Top + Picture1.Height)-(Picture1.Left + i, Picture1.Top + Picture1.Height + 100)
Beschriftung = CStr(Mid(Zeitarray(Zhler), 1, 2))
UserControl.CurrentX = Picture1.Left + i - (UserControl.TextWidth(Beschriftung) \ 2)
UserControl.CurrentY = Picture1.Top + Picture1.Height + 150
UserControl.ForeColor = m_FarbeNummern
Print Beschriftung
UserControl.ForeColor = m_FarbeScalierung
End If
End If

Case 2 'jede Stunde Scala
If Mid(Zeitarray(Zhler), 4, 2) = "00" Then 'jede volle Stunde
UserControl.Line (Picture1.Left + i, Picture1.Top + Picture1.Height)-(Picture1.Left + i, Picture1.Top + Picture1.Height + 100)
Beschriftung = CStr(Mid(Zeitarray(Zhler), 1, 2))
UserControl.CurrentX = Picture1.Left + i - (UserControl.TextWidth(Beschriftung) \ 2)
UserControl.CurrentY = Picture1.Top + Picture1.Height + 150
UserControl.ForeColor = m_FarbeNummern
Print Beschriftung
UserControl.ForeColor = m_FarbeScalierung
End If

Case 3 'jede halbe Stunde Scala
If Mid(Zeitarray(Zhler), 4, 2) = "00" Then 'jede volle Stunde
UserControl.Line (Picture1.Left + i, Picture1.Top + Picture1.Height)-(Picture1.Left + i, Picture1.Top + Picture1.Height + 100)
Beschriftung = CStr(Mid(Zeitarray(Zhler), 1, 2))
UserControl.CurrentX = Picture1.Left + i - (UserControl.TextWidth(Beschriftung) \ 2)
UserControl.CurrentY = Picture1.Top + Picture1.Height + 100
UserControl.ForeColor = m_FarbeNummern
Print Beschriftung
UserControl.ForeColor = m_FarbeScalierung
End If
If Mid(Zeitarray(Zhler), 4, 2) = "30" Then 'jede halbe Stunde
UserControl.Line (Picture1.Left + i, Picture1.Top + Picture1.Height)-(Picture1.Left + i, Picture1.Top + Picture1.Height + 50)
End If

Case 4 ' jede 1/4 Stunde Scala
If Mid(Zeitarray(Zhler), 4, 2) = "00" Then 'jede volle Stunde
UserControl.Line (Picture1.Left + i, Picture1.Top + Picture1.Height)-(Picture1.Left + i, Picture1.Top + Picture1.Height + 100)
Beschriftung = CStr(Mid(Zeitarray(Zhler), 1, 2))
UserControl.CurrentX = Picture1.Left + i - (UserControl.TextWidth(Beschriftung) \ 2)
UserControl.CurrentY = Picture1.Top + Picture1.Height + 100
UserControl.ForeColor = m_FarbeNummern
Print Beschriftung
UserControl.ForeColor = m_FarbeScalierung
End If
Select Case Mid(Zeitarray(Zhler), 4, 2)
Case "15", "30", "45"
UserControl.Line (Picture1.Left + i, Picture1.Top + Picture1.Height)-(Picture1.Left + i, Picture1.Top + Picture1.Height + 50)
End Select
End Select
i = i + Picture1.Width \ 96
Next Zhler
ReDim Y_Achse(96)
For i = 0 To 96 'y-Array (Werteachse) erstellen
If WertearrayFertig(i) < 0 Then
Y_Achse(i) = -1  'keine Daten vorhanden
Else
Y_Achse(i) = (BerechneWerty(Hhenwert, WertearrayFertig(i), Picture1.ScaleHeight - Ausgleich))
End If
Next i

ReDim X_Achse(96)
Picturepunkt = 0
Zhler = 0
For i = 0 To 96 'x-Array fllen (Zeitachse)
X_Achse(i) = Picturepunkt  'Array Zeitachse (x) erstellen
Picturepunkt = Picturepunkt + (Picture1.ScaleWidth \ 96)
Next i
Picture1.ForeColor = m_FarbeLinie
For i = 0 To 95 'Liniendiagramm zeichnen
If Y_Achse(i) <> -1 And Y_Achse(i + 1) <> -1 Then 'Wert vorhanden
Picture1.Line (X_Achse(i), Picture1.ScaleHeight - Y_Achse(i))-(X_Achse(i + 1), Picture1.ScaleHeight - Y_Achse(i + 1))
End If
Next i
Picture1.Width = Picture1.Width + 1 'damit letzter Wert korrekt dargestellt wird
End Sub
Public Sub WerteEinlesen(Tag1() As Long, Tag2() As Long) 'Werte in Ctl einlesen
Attribute WerteEinlesen.VB_Description = "bergabe der Werte"
Dim i As Long
ReDim WerteTag1(95)
ReDim WerteTag2(95)
For i = 0 To 95
WerteTag1(i) = Tag1(i)
WerteTag2(i) = Tag2(i)
Next i
AutoScale = True
End Sub

Private Sub ErstelleZeitarray(Anfangsstunde As Integer, Anfangsminute As Integer, Startindexnummer As Integer) 'Zeitarray passend zu Wertearray erstellen
Dim Stundenstring As String
Dim Zeitstring As String
Dim bergabearray() As String 'nur als Hilfe
Dim Zhler As Long
Dim i As Long

ReDim bergabearray(95) '24 Stunden
For i = 0 To 23
Stundenstring = Format(i, "00")
Stundenstring = Stundenstring & ":"
For Zhler = 0 To 45 Step 15
Zeitstring = Stundenstring & Format(Zhler, "00")
bergabearray((i * 4) + (Zhler / 15)) = Zeitstring
Next Zhler
Next i
Zhler = 0
'In aktuelles Zeitindexarray einordnen
ReDim Zeitarray(96) '24 Stunden + Endpunkt (z. B. zweimal 00:00)
For i = Startindexnummer To 95
Zeitarray(Zhler) = bergabearray(i)
Zhler = Zhler + 1
Next i
For i = 0 To Startindexnummer
Zeitarray(Zhler) = bergabearray(i)
Zhler = Zhler + 1
Next i
End Sub

Private Sub WertearrayErstellen(Startindexnummer As Integer)
Dim bergabe As Long
Dim Zhler As Long
Dim i As Long
Dim Testlong As Long
Dim Testlong1 As Long

ReDim WertearrayFertig(96) 'Werte-Array erstellen nach Zeit geordnet
bergabe = AktHchstwert
For i = Startindexnummer To 95 'Wertearray mit Daten Tag 1 fllen
WertearrayFertig(Zhler) = WerteTag1(i)
Zhler = Zhler + 1
Next i
For i = 0 To Startindexnummer 'Wertearray mit Daten Tag 2 fllen
WertearrayFertig(Zhler) = WerteTag2(i)
Zhler = Zhler + 1
Next i
'den hchsten Wert des entsprechenden Zeitraumes herausfiltern
AktHchstwert = 0
For i = 0 To 96
If AktHchstwert < WertearrayFertig(i) Then
AktHchstwert = WertearrayFertig(i)
'If AktHchstwert > bergabe Then 'Test
'reagierenicht = 1
'Testlong1 = SucheAHScalierung(Testlong)
'DiaEndWert = Testlong
'reagierenicht = 0
'End If
End If
Next i
If AutoScale = True Then
reagierenicht = 1
bergabe = SucheAHScalierung(Testlong)
DiaEndWert = Testlong
ScalierungWert = bergabe
UserControl.Refresh
reagierenicht = 0
End If

End Sub

Private Function SucheAHScalierung(Hochwert As Long) As Long
Dim DiagrHoch As Long
Dim Scalgr As Long
Select Case AktHchstwert 'Scalierung automatisch suchen (leicht eigenen Wnschen anpasspar)
Case Is <= 20
DiagrHoch = 20
Scalgr = 1
Case Is <= 50
DiagrHoch = 50
Scalgr = 5
Case Is <= 200
DiagrHoch = 200
Scalgr = 10
Case Is <= 500
DiagrHoch = 500
Scalgr = 25
Case Is <= 1000
DiagrHoch = 1000
Scalgr = 100
Case Is <= 2500
DiagrHoch = 2500
Scalgr = 200
Case Is <= 5000
DiagrHoch = 5000
Scalgr = 500
Case Is <= 10000
DiagrHoch = 10000
Scalgr = 1000
Case Is <= 15000
DiagrHoch = 15000
Scalgr = 1000
Case Is <= 20000
DiagrHoch = 20000
Scalgr = 2000
Case Is <= 50000
DiagrHoch = 50000
Scalgr = 5000
Case Is <= 100000
DiagrHoch = 100000
Scalgr = 20000
Case Else
DiagrHoch = 250000
Scalgr = 25000
End Select
SucheAHScalierung = Scalgr
Hochwert = DiagrHoch
End Function

Private Function BerechneWerty(Hchstwert As Long, Wert As Long, Gesamthhe As Long) As Long
Dim Hilfslong As Long
Dim Testhchstwert As Double
Dim Testgesamthhe As Double
Dim Testwert As Double
Dim Testdouble As Double

If Wert <= 0 Then
BerechneWerty = 0
Else
Testhchstwert = Hchstwert 'Umwandeln auf Double wegen Rechengenauigkeit
Testgesamthhe = Gesamthhe
Testwert = Wert
Testdouble = Testhchstwert / Testwert
Testdouble = Testgesamthhe / Testdouble
BerechneWerty = CLng(Testdouble) 'zuweisen
If BerechneWerty = 0 Then BerechneWerty = 1
End If
End Function
